#include <Xml\XmlBase.mqh>

class CNeuron;
class CLink;
class CNet;

#include "Links.mqh"
#include "Neurons.mqh"
#include "Nets.mqh"

bool IsLike (const string str, const string pattern) {
  return (
    str==pattern || 
   (StringSubstr(pattern,StringLen(pattern)-1,1)=="*" &&
    StringSubstr(str,0,StringLen(pattern)-1)==StringSubstr(pattern,0,StringLen(pattern)-1))
  );
};

ENUM_TIMEFRAMES GetTimeFrame(string s) 
{
  if (s=="M1") return(PERIOD_M1); else
  if (s=="M5") return(PERIOD_M5); else
  if (s=="M15") return(PERIOD_M15); else
  if (s=="M30") return(PERIOD_M30); else
  if (s=="H1") return(PERIOD_H1); else
  if (s=="H4") return(PERIOD_H4); else
  if (s=="D1") return(PERIOD_D1); else
  if (s=="W1") return(PERIOD_W1); else
  if (s=="MN1") return(PERIOD_MN1); else
  return(_Period);
}

string GetTimeFrameName(ENUM_TIMEFRAMES tf) 
{
  if (tf==PERIOD_M1) return("M1"); else
  if (tf==PERIOD_M5) return("M5"); else
  if (tf==PERIOD_M15) return("M15"); else
  if (tf==PERIOD_M30) return("M30"); else
  if (tf==PERIOD_H1) return("H1"); else
  if (tf==PERIOD_H4) return("H4"); else
  if (tf==PERIOD_D1) return("D1"); else
  if (tf==PERIOD_W1) return("W1"); else
  if (tf==PERIOD_MN1) return("MN1"); else
  return("");
}

float tanhf(float x)
{
  float ep = (float)exp(x);
  float en = (float)exp(-x);
  return (float)((ep - en) / (ep + en));
}


//  CNet         XML-
//       CXmlElement  Upload-  
