//-----------------------------------------------------------------------------
//                                  CLink                                     !
//-----------------------------------------------------------------------------

class CLink {

protected:

  CXmlElement *FXmlElement;
  CNeuron     *FLeftNeuron;
  CNeuron     *FRightNeuron;

public:
  
  // Constructor procedures 
  
  void CLink ();
  virtual void ~CLink ();
  virtual bool Init (CXmlElement *aXmlElement, CNeuron* aParentNeuron);
  virtual void Upload ();

  // Main procedures 

  // Service procedures

  CXmlElement* GetXmlElement(); 
  
  CNeuron* GetLeftNeuron () const;
  void     SetLeftNeuron (CNeuron* aNeuron);
  CNeuron* GetRightNeuron () const;
  void     SetRightNeuron (CNeuron* aNeuron);
  
};

//--------------------------------------------------------------------------------/
//                                CLink :: implementation                         /
//--------------------------------------------------------------------------------/
  
void CLink::CLink() 
{
  FXmlElement = NULL;
  FLeftNeuron = NULL;
  FRightNeuron = NULL;
};
  
void CLink::~CLink() 
{
};
  
bool CLink::Init (CXmlElement *aXmlElement, CNeuron* aParentNeuron) 
{
  FXmlElement=aXmlElement;
  SetLeftNeuron (aParentNeuron.GetNet().GetNeuron (FXmlElement.GetAttributeValue("TO")));
  SetRightNeuron (aParentNeuron);
  return (FLeftNeuron!=NULL) && (FRightNeuron!=NULL);
};
  
void CLink::Upload() 
{
  if (FXmlElement.GetAttribute("TO")==NULL) 
    FXmlElement.AttributeAdd(new CXmlAttribute).SetName("TO");
  FXmlElement.GetAttribute("TO").SetValue(FLeftNeuron.GetXmlElement().GetAttributeValue("NAME"));
};

CXmlElement* CLink::GetXmlElement() 
{
  return(FXmlElement);
};
  
CNeuron* CLink::GetLeftNeuron () const
{
  return (FLeftNeuron);
};

void CLink::SetLeftNeuron (CNeuron* aNeuron) 
{
  if (FLeftNeuron != NULL)
    FLeftNeuron.DelRightLink(GetPointer(this));
  FLeftNeuron = aNeuron;
  if (FLeftNeuron != NULL)
    FLeftNeuron.AddRightLink(GetPointer(this));
};

CNeuron* CLink::GetRightNeuron () const
{
  return (FRightNeuron);
};

void CLink::SetRightNeuron (CNeuron* aNeuron) 
{
  FRightNeuron = aNeuron;
};
  
