//-----------------------------------------------------------------------------
//                                  CLinkWeight                               !
//-----------------------------------------------------------------------------

class CLinkWeight : public CLink {

private:

  float FWeight;
  
public:

  // Constructor procedures 

  void CLinkWeight ();
  virtual void ~CLinkWeight ();
  virtual bool Init (CXmlElement *aXmlElement, CNeuron* aParentNeuron);
  virtual void Upload();
//  virtual void Clear();

  // Main procedures 
  
  // Service procedures

  float  GetWeight ();
  void   SetWeight (float aWeight);
};

//--------------------------------------------------------------------------------/
//                                CLinkWeight :: implementation                         /
//--------------------------------------------------------------------------------/
  
void CLinkWeight::CLinkWeight ()
{
  FWeight = FLT_MAX;
};

void CLinkWeight::~CLinkWeight ()
{
};

bool CLinkWeight::Init (CXmlElement* aXmlElement, CNeuron* aParentNeuron) 
{
  bool r = CLink::Init (aXmlElement, aParentNeuron);

  if (FXmlElement.GetAttribute("WEIGHT")!=NULL)
    FWeight = (float)StringToDouble(FXmlElement.GetAttributeValue("WEIGHT"));
  else {
    float rnd=(float)StringToDouble(FXmlElement.GetAttributeValue("RND"));
    FWeight = (float)((MathRand() / 32767.0 * 2.0f - 1.0f) * rnd);
    FXmlElement.AttributeDelete(FXmlElement.GetAttribute("RND"));
    FXmlElement.AttributeAdd(new CXmlAttribute).SetName("WEIGHT");
  };
      
  return r && (FXmlElement.GetAttribute("RND")!=NULL || FXmlElement.GetAttribute("WEIGHT")!=NULL);
};

void CLinkWeight::Upload() 
{
  CLink::Upload();
  
  if (FXmlElement.GetAttribute("WEIGHT")==NULL) 
    FXmlElement.AttributeAdd(new CXmlAttribute).SetName("WEIGHT");
  
  FXmlElement.GetAttribute("WEIGHT").SetValue (DoubleToString (FWeight,-8));
};

/*void CLinkWeight::Clear() 
{
  CLink::Clear();
  FWeight = FLT_MAX;
};*/

float CLinkWeight::GetWeight () 
{
  return (FWeight);
};

void CLinkWeight::SetWeight (float aWeight) 
{
  FWeight = aWeight;
};
