//#include <Xml\XmlBase.mqh>
#include <Cuda\Base.mqh>

//-----------------------------------------------------------------------------
//                                   CNet                                     !
//-----------------------------------------------------------------------------

class CNet {
public:
  CXmlDocument FXmlDoc;
  CNeuron* FNeurons[];
//  CLink*   FLinks[];
  datetime FPoint;    // Input      
  
  void CNet () 
  {
  };
  
  void ~CNet () 
  {
    Clear ();
  };
  
  void Clear ()
  {
    for (int i=ArraySize(FNeurons)-1; i>=0; --i) 
      delete FNeurons[i];
    ArrayResize (FNeurons,0);

/*    for (int i=0; i<ArraySize(FLinks); ++i) 
      delete FLinks[i];
    ArrayResize (FLinks,0);*/
  };

  void UnTemplateNeurons (CXmlElement &xmlItem) 
  {
    int i = 0;
    while (i<xmlItem.GetChildCount()) { 
      if (
        (xmlItem.GetChild(i).GetName() == "NEURON") && 
        (xmlItem.GetChild(i).GetAttribute("COUNT") != NULL) 
      )
      {
        CXmlElement* xmlNeuron = xmlItem.GetChild(i);
        long count = StringToInteger(xmlNeuron.GetAttributeValue("COUNT"));
        string name = xmlNeuron.GetAttributeValue("NAME");
        int p = StringFind(name,"*");

        for (int j=1; j<=count; j++) 
        {
          CXmlElement* new_item = new CXmlElement;
          xmlNeuron.CopyTo (new_item);
          new_item.AttributeDelete(new_item.GetAttribute("COUNT"));        
          if (p>-1) 
            new_item.GetAttribute("NAME").SetValue(StringSubstr(name,0,p)+IntegerToString(j)+StringSubstr(name,p+1));
          xmlItem.ChildInsertAt(new_item, i);
          ++i;
        };
        xmlItem.ChildDelete (xmlNeuron);
        --i;
      }
      else
        UnTemplateNeurons (xmlItem.GetChild(i));
        
      ++i;
    };
  };
  
  bool LoadNeurons (CXmlElement &xmlItem) 
  {
    bool r=true;
    
    for (int i=0; i<xmlItem.GetChildCount(); i++) 
      if (xmlItem.GetChild(i).GetName() == "LAYER")
      {
        CXmlElement* layer = xmlItem.GetChild(i);
        for (int j=0; j<layer.GetChildCount(); ++j) 
        {        
          if (layer.GetChild(j).GetName() == "NEURON")
          {
            ArrayResize(FNeurons,ArraySize(FNeurons)+1);
            FNeurons[ArraySize(FNeurons)-1]=CreateNeuron(xmlItem.GetChild(i).GetAttributeValue("CLASS"));
              
            r = r && FNeurons[ArraySize(FNeurons)-1].Init(layer.GetChild(j),GetPointer(this));
              
          }
        }
      } 
  /*  for (int j = 0; j < ArraySize(FNeurons)-1; ++j)
      r = r && 
      (
        FNeurons[j].GetXmlElement().GetAttributeValue("NAME") != 
        FNeurons[ArraySize(FNeurons)-1].GetXmlElement().GetAttributeValue("NAME")
      );*/
    return r;
  };

 
  
/*  virtual bool LoadBlock (CXmlElement &xmlBlock)
  {
    bool r=true;

        
    // UnTemplate LINKs
    
    for (int i=0; i<xmlBlock.GetChildCount(); ++i) 
      if (xmlBlock.GetChild(i).GetName() == "LINK") 
        UnTemplateLink (xmlBlock.GetChild(i));

    // Load LINKs
    
    for (int i=0; i<xmlBlock.GetChildCount(); i++) 
      if (xmlBlock.GetChild(i).GetName() == "LINK")
        r = r && LoadLink (xmlBlock.GetChild(i));

    // Load BLOCKs
    
    else
        r = r && LoadBlock(xmlBlock.GetChild(i));
    
    return r;
  };
*/  
  virtual bool LoadFrom (CXmlElement &xmlNet) 
  {
    xmlNet.CopyTo (FXmlDoc.FDocumentElement);
    bool r = false;
    
    // Load NEURONs
    
 //   UnTemplateNeurons (FXmlDoc.FDocumentElement);
    r = LoadNeurons (xmlNet);
    
    return r;
  };
  
  virtual void SaveTo (CXmlDocument &xmlNet) {

    for (int i=0; i<ArraySize(FNeurons); ++i)
      FNeurons[i].Upload ();
/*    for (int i=0; i<ArraySize(FLinks); ++i)
      FLinks[i].Upload ();*/
    FXmlDoc.CopyTo (xmlNet);
  };

  virtual bool Run() {
    bool r = true;
    for (int i=0; i<ArraySize(FNeurons); i++) {
      r = r && FNeurons[i].Run();
      if (FNeurons[i].GetValue()==FLT_MAX)
        return(false);
    };
    return r;
  };
  
  CNeuron* GetNeuron (string aName)
  {
    for (int i=0; i<ArraySize(FNeurons); ++i)
      if (FNeurons[i].GetXmlElement().GetAttributeValue("NAME") == aName)
        return FNeurons[i];
    return NULL;
  };
};
