//-----------------------------------------------------------------------------
//                                  CNeuronCos                               !
//-----------------------------------------------------------------------------

class CNeuronCos : public CNeuronLinear {

protected:

  float   FCos;

public:

  void CNeuronCos ();
  virtual void ~CNeuronCos ();
//  virtual void Clear ();

  virtual bool Run ();

  virtual float GetValue ();
  virtual float GetdFdLink (const CLink *aLink);
  virtual float GetdFdNeuron (const CNeuron *aNeuron);

};

//-----------------------------------------------------------------------------
//                                  CNeuronCos :: implementation             !
//-----------------------------------------------------------------------------

void CNeuronCos::CNeuronCos () 
{
  FCos=FLT_MAX;
};
  
void CNeuronCos::~CNeuronCos ()
{
};

float CNeuronCos::GetValue () 
{
  return (FCos);
};

bool CNeuronCos::Run () 
{
  bool r = CNeuronLinear::Run();
  FCos = (float)MathCos(FSum);
  return r && (FCos != FLT_MAX);
};
  
float CNeuronCos::GetdFdLink (const CLink *aLink) 
{
  return (
    (float)(CNeuronLinear::GetdFdLink(aLink) * ( -MathSin(FSum) ))
  );
};
  
float CNeuronCos::GetdFdNeuron (const CNeuron *aNeuron) 
{
  return (
    (float)(CNeuronLinear::GetdFdNeuron(aNeuron) * ( -MathCos(FSum) ))
  );
};
