//-----------------------------------------------------------------------------
//                                  CNeuronCycled                             !
//-----------------------------------------------------------------------------

class CNeuronCycled : public CNeuron 
{
protected :

  float FValue;
  CNeuron* FSourceNeuron;

public :

  // Constructor procedures 

  void          CNeuronCycled ();
  virtual void ~CNeuronCycled ();
  
  virtual bool Init (CXmlElement *aXmlElement, CNet *aNet);
  virtual void Upload ();
//  virtual void Clear ();
  
  // Main procedures 

  virtual bool Run ();
  int GetLayer ();  
  virtual float GetValue ();
  void SetValue (float aValue);
  virtual float GetdFdLink (const CLink *aLink);
  virtual float GetdFdNeuron (const CNeuron *aNeuron);
};

//--------------------------------------------------------------------------------/
//                              CNeuronMSE :: implementation                      /
//--------------------------------------------------------------------------------/
  
  // Constructor procedures 

void CNeuronCycled::CNeuronCycled ()
{
  FValue = FLT_MAX;
  FSourceNeuron = NULL;
};

void CNeuronCycled::~CNeuronCycled ()
{
};

bool CNeuronCycled::Init (CXmlElement *aXmlElement, CNet *aNet)
{
  bool r = CNeuron::Init(aXmlElement, aNet);
  FSourceNeuron = FNet.GetNeuron (FXmlElement.GetAttributeValue("SOURCE"));
  return r && (FSourceNeuron!=NULL);
};

void CNeuronCycled::Upload () {
  CNeuron::Upload();
  FXmlElement.GetAttribute("SOURCE").SetValue(FSourceNeuron.GetXmlElement().GetAttributeValue("NAME"));
};

  // Main procedures 

bool CNeuronCycled::Run ()
{
  FValue = FSourceNeuron.GetValue();
  return FValue != FLT_MAX;
};

int CNeuronCycled::GetLayer ()
{
  return 0.0f;
};

float CNeuronCycled::GetValue ()
{
  return FValue;
};

float CNeuronCycled::GetdFdLink (const CLink *aLink)
{
  return 0.0f;
};

float CNeuronCycled::GetdFdNeuron (const CNeuron *aNeuron)
{
 if (aNeuron == GetPointer(this))
   return 1.0f;
 else
   return 0.0f;
};