//-----------------------------------------------------------------------------
//                                  CNeuronCycled                             !
//-----------------------------------------------------------------------------

class CNeuronService : public CNeuron 
{
protected :

  float FValue;

public :

  // Constructor procedures 

  void          CNeuronService ();
  virtual void ~CNeuronService ();
  
  virtual bool Init (CXmlElement *aXmlElement, CNet *aNet);
  virtual void Upload ();
//  virtual void Clear ();
  
  // Main procedures 

  virtual bool Run ();
  int GetLayer ();  
  virtual float GetValue ();
  void SetValue (float aValue);
  virtual float GetdFdLink (const CLink *aLink);
  virtual float GetdFdNeuron (const CNeuron *aNeuron);
};

//--------------------------------------------------------------------------------/
//                              CNeuronMSE :: implementation                      /
//--------------------------------------------------------------------------------/
  
  // Constructor procedures 

void CNeuronService::CNeuronService ()
{
  FValue = 0.0f;
};

void CNeuronService::~CNeuronService ()
{
};

bool CNeuronService::Init (CXmlElement *aXmlElement, CNet *aNet)
{
  bool r = CNeuron::Init(aXmlElement, aNet);
  CXmlAttribute* value = aXmlElement.GetAttribute("VALUE");
  if (value)
    SetValue((float)StringToDouble(value.GetValue()));
  return r;
};

void CNeuronService::Upload () {
  CNeuron::Upload();
};

  // Main procedures 

bool CNeuronService::Run ()
{
  return FValue != FLT_MAX;
};

int CNeuronService::GetLayer ()
{
  return 0.0f;
};

float CNeuronService::GetValue ()
{
  return FValue;
};

void CNeuronService::SetValue (float aValue)
{
  FValue = aValue;
}

float CNeuronService::GetdFdLink (const CLink *aLink)
{
  return 0.0f;
};

float CNeuronService::GetdFdNeuron (const CNeuron *aNeuron)
{
 if (aNeuron == GetPointer(this))
   return 1.0f;
 else
   return 0.0f;
};