//-----------------------------------------------------------------------------
//                                  CNeuronSigmoid                            !
//-----------------------------------------------------------------------------

class CNeuronSigmoid : public CNeuronLinear {
protected:

  float   FSigmoid;

public:

  void CNeuronSigmoid ();
  
  virtual bool Run ();
  virtual float GetValue (); 

  virtual float GetdFdLink (const CLink *aLink);
  virtual float GetdFdNeuron (const CNeuron *aNeuron);

};

//--------------------------------------------------------------------------------/
//                               CNeuronSigmoid :: implementation                 /
//--------------------------------------------------------------------------------/
  
void CNeuronSigmoid::CNeuronSigmoid () 
{
  FSigmoid=FLT_MAX;
};
  
float CNeuronSigmoid::GetValue () 
{
  return (FSigmoid);
};

bool CNeuronSigmoid::Run () 
{
  bool r = CNeuronLinear::Run ();
  FSigmoid = (float)(1 / (1 + exp(-FSum)));
  return r && (FSigmoid != FLT_MAX);
};
  
float CNeuronSigmoid::GetdFdLink (const CLink *aLink) 
{
  return (
    CNeuronLinear::GetdFdLink(aLink) * FSigmoid * (1 - FSigmoid)
  );
};
  
float CNeuronSigmoid::GetdFdNeuron (const CNeuron *aNeuron) 
{
  return (
    CNeuronLinear::GetdFdNeuron(aNeuron) * FSigmoid * (1 - FSigmoid)
  );
};
