//-----------------------------------------------------------------------------
//                                  CNeuronSin                               !
//-----------------------------------------------------------------------------

class CNeuronSin : public CNeuronLinear {

protected:

  float   FSin;

public:

  void CNeuronSin ();
  virtual void ~CNeuronSin ();
//  virtual void Clear ();

  virtual bool Run ();

  virtual float GetValue ();
  virtual float GetdFdLink (const CLink *aLink);
  virtual float GetdFdNeuron (const CNeuron *aNeuron);

};

//-----------------------------------------------------------------------------
//                                  CNeuronSin :: implementation             !
//-----------------------------------------------------------------------------

void CNeuronSin::CNeuronSin () 
{
  FSin=FLT_MAX;
};
  
void CNeuronSin::~CNeuronSin ()
{
};

float CNeuronSin::GetValue () 
{
  return (FSin);
};

bool CNeuronSin::Run () 
{
  bool r = CNeuronLinear::Run();
  FSin = (float)MathSin(FSum);
  return r && (FSin != FLT_MAX);
};
  
float CNeuronSin::GetdFdLink (const CLink *aLink) 
{
  return (
    (float)(CNeuronLinear::GetdFdLink(aLink) * MathCos(FSum))
  );
};
  
float CNeuronSin::GetdFdNeuron (const CNeuron *aNeuron) 
{
  return (
    (float)(CNeuronLinear::GetdFdNeuron(aNeuron) * MathCos(FSum))
  );
};
