//-----------------------------------------------------------------------------
//                                  CNeuronTanh                               !
//-----------------------------------------------------------------------------

class CNeuronTanh : public CNeuronLinear {

protected:

  float   FTanh;

public:

  void CNeuronTanh ();
  virtual void ~CNeuronTanh ();
//  virtual void Clear ();

  virtual bool Run ();

  virtual float GetValue ();
  virtual float GetdFdLink (const CLink *aLink);
  virtual float GetdFdNeuron (const CNeuron *aNeuron);

};

//-----------------------------------------------------------------------------
//                                  CNeuronTanh :: implementation             !
//-----------------------------------------------------------------------------

void CNeuronTanh::CNeuronTanh () 
{
  FTanh=FLT_MAX;
};
  
void CNeuronTanh::~CNeuronTanh ()
{
};

float CNeuronTanh::GetValue () 
{
  return (FTanh);
};

bool CNeuronTanh::Run () 
{
  bool r = CNeuronLinear::Run();
/*  double ep = exp(FSum);
  double en = exp(-FSum);
  FTanh = (float)((ep - en) / (ep + en));*/
  FTanh = tanhf(FSum);
  return r && (FTanh != FLT_MAX);
};
  
float CNeuronTanh::GetdFdLink (const CLink *aLink) 
{
  return (
    CNeuronLinear::GetdFdLink(aLink) * (1 - FTanh * FTanh)
  );
};
  
float CNeuronTanh::GetdFdNeuron (const CNeuron *aNeuron) 
{
  return (
    CNeuronLinear::GetdFdNeuron(aNeuron) * (1 - FTanh * FTanh)
  );
};
