//+------------------------------------------------------------------+
//|                                                 XmlAttribute.mqh |
//|                                                   yu-sha@ukr.net |
//+------------------------------------------------------------------+

//-----------------------------------------------------------------------------
//                                  CXmlAttribute                             !
//-----------------------------------------------------------------------------

class CXmlAttribute 
{
  private:

    string FName;
    string FValue;

  public:

    // Constructor procedures
  
    void CXmlAttribute ();
    void ~CXmlAttribute ();

    void Init (const string aName, const string aValue);
    virtual void Clear ();
    virtual CXmlAttribute* Clone ();
    
    // Service procedures

    string GetName () const;
    void SetName (const string aName);
    string GetValue () const;
    void SetValue (const string aValue);
    
};

//--------------------------------------------------------------------------------/
//                              CXmlAttribute :: implementation                   /
//--------------------------------------------------------------------------------/
  
void CXmlAttribute::CXmlAttribute()
{
  FName="";
  FValue="";
};

void CXmlAttribute::~CXmlAttribute () 
{
  Clear ();
};

void CXmlAttribute::Init (const string aName, const string aValue="")
{
  SetName (aName);
  SetValue (aValue);
};

void CXmlAttribute::Clear ()
{
};

CXmlAttribute* CXmlAttribute::Clone () 
{
  CXmlAttribute *a = new CXmlAttribute;
  a.FName=FName;
  a.FValue=FValue;
  return a; 
};

string CXmlAttribute::GetName () const
{
  return FName;
};

void CXmlAttribute::SetName (const string aName) 
{
  FName = aName;
};
    
string CXmlAttribute::GetValue () const
{
  return FValue;
};

void CXmlAttribute::SetValue (const string aValue)
{
  FValue = aValue;
};
